/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2019/05/01 00:00:00
// Module Name   : colour_bar_dat_gen
// Description   : ʾݲģ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////

module colour_bar_dat_gen
#(
  parameter DISP_WIDTH  = 640,
  parameter DISP_HEIGHT = 480
)
(
  input      [11:0]disp_h_addr,
  input      [11:0]disp_v_addr,

  input            disp_data_req,
  output reg [23:0]disp_data
);
  //ɫ
  localparam 
    BLACK    = 24'h000000, //ɫ
    BLUE     = 24'h0000FF, //ɫ
    RED      = 24'hFF0000, //ɫ
    PURPPLE  = 24'hFF00FF, //ɫ
    GREEN    = 24'h00FF00, //ɫ
    CYAN     = 24'h00FFFF, //ɫ
    YELLOW   = 24'hFFFF00, //ɫ
    WHITE    = 24'hFFFFFF; //ɫ
    
  //ÿؿĬʾɫֵ
  localparam 
    R0_C0 = BLACK,   //00ؿ
    R0_C1 = BLUE,    //01ؿ
    R1_C0 = RED,     //10ؿ
    R1_C1 = PURPPLE, //11ؿ
    R2_C0 = GREEN,   //20ؿ
    R2_C1 = CYAN,    //21ؿ
    R3_C0 = YELLOW,  //30ؿ
    R3_C1 = WHITE;   //31ؿ
  
  wire R0_act, R1_act, R2_act, R3_act;
  wire C0_act, C1_act;
  wire R0_C0_act, R0_C1_act;
  wire R1_C0_act, R1_C1_act;
  wire R2_C0_act, R2_C1_act;
  wire R3_C0_act, R3_C1_act;

  assign R0_act = disp_v_addr >= 0               && disp_v_addr < DISP_HEIGHT/4;   //ɨ0
  assign R1_act = disp_v_addr >= DISP_HEIGHT/4   && disp_v_addr < DISP_HEIGHT/2;   //ɨ1
  assign R2_act = disp_v_addr >= DISP_HEIGHT/2   && disp_v_addr < DISP_HEIGHT/4*3; //ɨ2
  assign R3_act = disp_v_addr >= DISP_HEIGHT/4*3 && disp_v_addr < DISP_HEIGHT;     //ɨ3
  assign C0_act = disp_h_addr >= 0               && disp_h_addr < DISP_WIDTH/2;    //ɨ0
  assign C1_act = disp_h_addr >= DISP_WIDTH/2    && disp_h_addr < DISP_WIDTH;      //ɨ1

  assign R0_C0_act = disp_data_req && R0_act && C0_act;  //00ؿ鴦ڱɨб־ź
  assign R0_C1_act = disp_data_req && R0_act && C1_act;  //01ؿ鴦ڱɨб־ź
  assign R1_C0_act = disp_data_req && R1_act && C0_act;  //10ؿ鴦ڱɨб־ź
  assign R1_C1_act = disp_data_req && R1_act && C1_act;  //11ؿ鴦ڱɨб־ź
  assign R2_C0_act = disp_data_req && R2_act && C0_act;  //20ؿ鴦ڱɨб־ź
  assign R2_C1_act = disp_data_req && R2_act && C1_act;  //21ؿ鴦ڱɨб־ź
  assign R3_C0_act = disp_data_req && R3_act && C0_act;  //30ؿ鴦ڱɨб־ź
  assign R3_C1_act = disp_data_req && R3_act && C1_act;  //31ؿ鴦ڱɨб־ź

  always@(*)
    case({R3_C1_act,R3_C0_act,R2_C1_act,R2_C0_act,
          R1_C1_act,R1_C0_act,R0_C1_act,R0_C0_act})
      8'b0000_0001:disp_data = R0_C0;
      8'b0000_0010:disp_data = R0_C1;
      8'b0000_0100:disp_data = R1_C0;
      8'b0000_1000:disp_data = R1_C1;
      8'b0001_0000:disp_data = R2_C0;
      8'b0010_0000:disp_data = R2_C1;
      8'b0100_0000:disp_data = R3_C0;
      8'b1000_0000:disp_data = R3_C1;
      default:disp_data = R0_C0;
    endcase

endmodule