/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2019/05/01 00:00:00
// Module Name   : hdmi_clour_bar
// Description   : HDMIӿڵĲʾ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////

module hdmi_clour_bar(
  clk50m,
  reset_n,
  //hdmi1 interface
  hdmi1_clk_p,
  hdmi1_clk_n,
  hdmi1_dat_p,
  hdmi1_dat_n,
  
  //TFT Interface
  TFT_rgb,
  TFT_hs,
  TFT_vs,
  TFT_clk,
  TFT_de,
  TFT_pwm
);
  input clk50m;
  input reset_n;
  //hdmi1 interface
  output hdmi1_clk_p;
  output hdmi1_clk_n;
  output [2:0]hdmi1_dat_p;
  output [2:0]hdmi1_dat_n;

  //TFT Interface
  output [15:0] TFT_rgb;//TFT
  output TFT_hs;        //TFTͬź
  output TFT_vs;        //TFTͬź
  output TFT_clk;       //TFTʱ
  output TFT_de;        //TFTʹ
  output TFT_pwm;       //TFT

//Resolution_1280x720   1 //ʱΪ74.25MHz
parameter DISP_WIDTH  = 800;
parameter DISP_HEIGHT = 480;

  wire pixelclk;
  wire pixelclk5x;
  wire pll_locked;

  wire reset_p;
  wire [11:0] disp_h_addr;
  wire [11:0] disp_v_addr;
  wire disp_data_req;
  wire [23:0]disp_data;
  wire disp_hs;
  wire disp_vs;
  wire [7:0]disp_red;
  wire [7:0]disp_green;
  wire [7:0]disp_blue;
  wire disp_de;
  wire disp_pclk;

  assign reset_p = ~pll_locked;

  pll pll
   (
    // Clock out ports
    .clk_out1(pixelclk   ),// output clk_out1
    .clk_out2(pixelclk5x ),// output clk_out2
    // Status and control signals
    .resetn  (reset_n    ),// input resetn
    .locked  (pll_locked ),// output locked
   // Clock in ports
    .clk_in1 (clk50m     ) // input clk_in1
  );

  colour_bar_dat_gen
  #(
    .DISP_WIDTH  ( DISP_WIDTH  ),
    .DISP_HEIGHT ( DISP_HEIGHT )
  )colour_bar_dat_gen(
    .disp_h_addr   (disp_h_addr  ),
    .disp_v_addr   (disp_v_addr  ),

    .disp_data_req (disp_data_req),
    .disp_data     (disp_data    )
  );

  disp_driver disp_driver(
    .ClkDisp     (pixelclk     ),
    .Rst_p       (reset_p      ),

    .Data        (disp_data    ),
    .DataReq     (disp_data_req),

    .H_Addr      (disp_h_addr  ),
    .V_Addr      (disp_v_addr  ),

    .Disp_HS     (disp_hs      ),
    .Disp_VS     (disp_vs      ),
    .Disp_Red    (disp_red     ),
    .Disp_Green  (disp_green   ),
    .Disp_Blue   (disp_blue    ),
    .frame_begin (             ),
    .Disp_DE     (disp_de      ),
    .Disp_PCLK   (disp_pclk    )
  );

  //TFT
  assign TFT_rgb = {disp_red[7:3],disp_green[7:2],disp_blue[7:3]};
  assign TFT_hs  = disp_hs;
  assign TFT_vs  = disp_vs;
  assign TFT_clk = disp_pclk;
  assign TFT_de  = disp_de;
  assign TFT_pwm = 1'b1;

  //HDMI1
  dvi_encoder dvi_encoder1(
    .pixelclk    (pixelclk    ),
    .pixelclk5x  (pixelclk5x  ),
    .rst_p       (reset_p     ),
    .blue_din    (disp_blue   ),
    .green_din   (disp_green  ),
    .red_din     (disp_red    ),
    .hsync       (disp_hs     ),
    .vsync       (disp_vs     ),
    .de          (disp_de     ),
    .tmds_clk_p  (hdmi1_clk_p ),
    .tmds_clk_n  (hdmi1_clk_n ),
    .tmds_data_p (hdmi1_dat_p ),
    .tmds_data_n (hdmi1_dat_n )
  );

endmodule